现在的位置: 首页 > 综合 > 正文

HDU 1087 Super Jumping! Jumping! Jumping! (最大子段和)

2018年04月28日 ⁄ 综合 ⁄ 共 2062字 ⁄ 字号 评论关闭

Super Jumping! Jumping! Jumping!

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 24426    Accepted Submission(s): 10772


Problem Description
Nowadays, a kind of chess game called “Super Jumping! Jumping! Jumping!” is very popular in HDU. Maybe you are a good boy, and know little about this game, so I introduce it to you now.

The game can be played by two or more than two players. It consists of a chessboard(棋盘)and some chessmen(棋子), and all chessmen are marked by a positive integer or “start” or “end”. The player starts from start-point and must jumps into end-point finally. In
the course of jumping, the player will visit the chessmen in the path, but everyone must jumps from one chessman to another absolutely bigger (you can assume start-point is a minimum and end-point is a maximum.). And all players cannot go backwards. One jumping
can go from a chessman to next, also can go across many chessmen, and even you can straightly get to end-point from start-point. Of course you get zero point in this situation. A player is a winner if and only if he can get a bigger score according to his
jumping solution. Note that your score comes from the sum of value on the chessmen in you jumping path.
Your task is to output the maximum value according to the given chessmen list.

 


Input
Input contains multiple test cases. Each test case is described in a line as follow:
N value_1 value_2 …value_N 
It is guarantied that N is not more than 1000 and all value_i are in the range of 32-int.
A test case starting with 0 terminates the input and this test case is not to be processed.
 


Output
For each case, print the maximum according to rules, and one line one case.
 


Sample Input
3 1 3 2 4 1 2 3 4 4 3 3 2 1 0
 


Sample Output
4 10 3

解题思路:

这道题是一道简单的DP问题,也就是求最大子段和,有点类似于LIS的写法,所以学习dp的前期只要认真的掌握其最为经典的模型才是王道,O(n2)的解法,估计还有更快的,但是目前只会写这个,等学会了,就来更新。两个for,第一个for从0->n扫一遍,第二个for从i+1->n扫一遍。然后呢,找出最大的子段和,再与_max来更新。

状态:dp[j]表示的是以value[j]结尾的最大字串和.

状态转移方程:dp[j] = max( dp[j],dp[i]+value[j] )

代码:

# include<cstdio>
# include<iostream>

using namespace std;

# define MAX 1234

int dp[MAX];
int value[MAX];

int main(void)
{
    int n;
    while ( cin>>n )
    {
        if ( n==0 )
            break;

        for ( int i = 0;i < n;i++ )
        {
            cin>>value[i];
            dp[i] = value[i];
        }
        int _max = dp[0];
        
        for ( int i = 0;i < n;i++ )
        {
            for ( int j = i+1;j < n;j++ )
            {
                if ( value[j] > value[i] )
                {
                    dp[j] = max( dp[j],dp[i]+value[j] );
                    _max = max( _max,dp[j]);
                }
            }
        }
        cout<<_max<<endl;

    }


    return 0;
}

抱歉!评论已关闭.